import React, { useEffect, useContext, useState, useCallback, isValidElement, cloneElement, useMemo } from 'react';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(source, true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(source).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function styleInject(css, ref) {
  if (ref === void 0) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') {
    return;
  }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".rh-form-field {\n  margin-bottom: 20px;\n  display: flex;\n  align-items: flex-start;\n  min-height: 32px;\n}\n.rh-form-field__header {\n  margin-right: 20px;\n  display: flex;\n  justify-content: flex-end;\n  align-items: center;\n  font-size: 14px;\n  text-align: right;\n  height: 32px;\n  width: 120px;\n}\n.rh-form-field__header::before {\n  display: none;\n  content: '*';\n  color: red;\n}\n.rh-form-field__container {\n  position: relative;\n  flex: 1;\n  margin-top: auto;\n  margin-bottom: auto;\n}\n.rh-form-field__message {\n  position: absolute;\n  top: 100%;\n  left: 0;\n  font-size: 12px;\n  color: red;\n}\n.rh-form-field__footer {\n  display: flex;\n  justify-content: flex-end;\n  align-items: center;\n  height: 32px;\n  margin-left: 10px;\n  font-size: 14px;\n}\n.rh-form-field .rh-form-field {\n  margin-bottom: 0;\n}\n.rh-form-field.rh-form-field--inline {\n  display: inline-flex;\n}\n.rh-form-field.rh-form-field--compact {\n  margin-bottom: 0;\n}\n.rh-form-field.rh-form-field--compact .rh-form-field__message {\n  display: none;\n}\n.rh-form-field.rh-form-field--required .rh-form-field__header::before {\n  display: inline;\n  content: '*';\n  color: red;\n}\n";
styleInject(css);

var FormStoreContext = React.createContext(undefined);

function useFieldChange(store, name, onChange) {
  useEffect(function () {
    if (!name || !store) return;
    return store.subscribe(function (n) {
      if (name === '*' || n === name || n === '*') {
        onChange(name);
      }
    });
  }, [name, store]);
}

var FormOptionsContext = React.createContext({});

function isObject(obj) {
  return obj !== null && _typeof(obj) === 'object';
}
function deepGet(obj, path) {
  var parts = path.split('.');
  var length = parts.length;

  for (var i = 0; i < length; i++) {
    if (!isObject(obj)) return undefined;
    obj = obj[parts[i]];
  }

  return obj;
}
function deepSet(obj, path, value) {
  if (!isObject(obj)) return obj;
  var root = obj;
  var parts = path.split('.');
  var length = parts.length;

  for (var i = 0; i < length; i++) {
    var p = parts[i];

    if (i === length - 1) {
      obj[p] = value;
    } else if (!isObject(obj[p])) {
      obj[p] = {};
    }

    obj = obj[p];
  }

  return root;
}
function deepCopy(target) {
  var type = _typeof(target);

  if (target === null || type === 'boolean' || type === 'number' || type === 'string') {
    return target;
  }

  if (target instanceof Date) {
    return new Date(target.getTime());
  }

  if (Array.isArray(target)) {
    return target.map(function (o) {
      return deepCopy(o);
    });
  }

  if (_typeof(target) === 'object') {
    var obj = {};

    for (var key in target) {
      obj[key] = deepCopy(target[key]);
    }

    return obj;
  }

  return undefined;
}
function getPropName(valueProp, type) {
  return typeof valueProp === 'function' ? valueProp(type) : valueProp;
}
function getValueFromEvent() {
  var e = arguments.length <= 0 ? undefined : arguments[0];
  return e && e.target ? e.target.type === 'checkbox' ? e.target.checked : e.target.value : e;
}

function FormField(props) {
  var className = props.className,
      label = props.label,
      name = props.name,
      _props$valueProp = props.valueProp,
      valueProp = _props$valueProp === void 0 ? 'value' : _props$valueProp,
      _props$valueGetter = props.valueGetter,
      valueGetter = _props$valueGetter === void 0 ? getValueFromEvent : _props$valueGetter,
      suffix = props.suffix,
      children = props.children,
      restProps = _objectWithoutProperties(props, ["className", "label", "name", "valueProp", "valueGetter", "suffix", "children"]);

  var store = useContext(FormStoreContext);
  var options = useContext(FormOptionsContext);

  var _useState = useState(name && store ? store.get(name) : undefined),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState(name && store ? store.error(name) : undefined),
      _useState4 = _slicedToArray(_useState3, 2),
      error = _useState4[0],
      setError = _useState4[1];

  var onChange = useCallback(function () {
    return name && store && store.set(name, valueGetter.apply(void 0, arguments));
  }, [name, store, valueGetter]);
  useFieldChange(store, name, function () {
    setValue(store.get(name));
    setError(store.error(name));
  });
  var child = children;

  if (name && store && isValidElement(child)) {
    var _childProps;

    var prop = getPropName(valueProp, child && child.type);
    var childProps = (_childProps = {}, _defineProperty(_childProps, prop, value), _defineProperty(_childProps, "onChange", onChange), _childProps);
    child = cloneElement(child, childProps);
  }

  var _options$restProps = _objectSpread2({}, options, {}, restProps),
      inline = _options$restProps.inline,
      compact = _options$restProps.compact,
      required = _options$restProps.required,
      labelWidth = _options$restProps.labelWidth,
      gutter = _options$restProps.gutter,
      errorClassName = _options$restProps.errorClassName;

  var classNames = [classes.field, inline ? classes.inline : '', compact ? classes.compact : '', required ? classes.required : '', error ? classes.error : '', className ? className : '', error ? errorClassName : ''].join('');
  var headerStyle = {
    width: labelWidth,
    marginRight: gutter
  };
  return React.createElement("div", {
    className: classNames
  }, label !== undefined && React.createElement("div", {
    className: classes.header,
    style: headerStyle
  }, label), React.createElement("div", {
    className: classes.container
  }, React.createElement("div", {
    className: classes.control
  }, child), React.createElement("div", {
    className: classes.message
  }, error)), suffix !== undefined && React.createElement("div", {
    className: classes.footer
  }, suffix));
}
var classes = {
  field: 'rh-form-field ',
  inline: 'rh-form-field--inline ',
  compact: 'rh-form-field--compact ',
  required: 'rh-form-field--required ',
  error: 'rh-form-field--error ',
  header: 'rh-form-field__header',
  container: 'rh-form-field__container',
  control: 'rh-form-field__control',
  message: 'rh-form-field__message',
  footer: 'rh-form-field__footer'
};

function FormItem(props) {
  var name = props.name,
      _props$valueProp = props.valueProp,
      valueProp = _props$valueProp === void 0 ? 'value' : _props$valueProp,
      _props$valueGetter = props.valueGetter,
      valueGetter = _props$valueGetter === void 0 ? getValueFromEvent : _props$valueGetter,
      children = props.children;
  var store = useContext(FormStoreContext);
  var options = useContext(FormOptionsContext);

  var _useState = useState(name && store ? store.get(name) : undefined),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState(name && store ? store.error(name) : undefined),
      _useState4 = _slicedToArray(_useState3, 2),
      error = _useState4[0],
      setError = _useState4[1];

  var onChange = useCallback(function () {
    return name && store && store.set(name, valueGetter.apply(void 0, arguments));
  }, [name, store, valueGetter]);
  useFieldChange(store, name, function () {
    setValue(store.get(name));
    setError(store.error(name));
  });
  var child = children;

  if (name && store && isValidElement(child)) {
    var _childProps;

    var errorClassName = options.errorClassName;
    var prop = getPropName(valueProp, child && child.type);
    var className = child.props && child.props.className || '';
    if (error) className += ' ' + errorClassName;
    var childProps = (_childProps = {
      className: className
    }, _defineProperty(_childProps, prop, value), _defineProperty(_childProps, "onChange", onChange), _childProps);
    child = cloneElement(child, childProps);
  }

  return child;
}

function Form(props) {
  var _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      children = props.children,
      store = props.store,
      onSubmit = props.onSubmit,
      options = _objectWithoutProperties(props, ["className", "children", "store", "onSubmit"]);

  var classNames = 'rh-form ' + className;
  return React.createElement(FormStoreContext.Provider, {
    value: store
  }, React.createElement(FormOptionsContext.Provider, {
    value: options
  }, React.createElement("form", {
    className: classNames,
    onSubmit: onSubmit
  }, children)));
}
Form.Field = FormField;
Form.Item = FormItem;

var FormStore =
/*#__PURE__*/
function () {
  function FormStore() {
    var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var rules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, FormStore);

    _defineProperty(this, "initialValues", void 0);

    _defineProperty(this, "listeners", []);

    _defineProperty(this, "values", void 0);

    _defineProperty(this, "rules", void 0);

    _defineProperty(this, "errors", {});

    this.initialValues = values;
    this.values = deepCopy(values);
    this.rules = rules;
    this.get = this.get.bind(this);
    this.set = this.set.bind(this);
    this.reset = this.reset.bind(this);
    this.error = this.error.bind(this);
    this.validate = this.validate.bind(this);
    this.subscribe = this.subscribe.bind(this);
  }

  _createClass(FormStore, [{
    key: "notify",
    value: function notify(name) {
      this.listeners.forEach(function (listener) {
        return listener(name);
      });
    }
  }, {
    key: "get",
    value: function get(name) {
      return name === undefined ? _objectSpread2({}, this.values) : deepGet(this.values, name);
    }
  }, {
    key: "set",
    value: function set(name, value) {
      var _this = this;

      var validate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (typeof name === 'string') {
        deepSet(this.values, name, value);
        if (validate) this.validate(name);
        this.notify(name);
      } else if (name) {
        Object.keys(name).forEach(function (n) {
          return _this.set(n, name[n]);
        });
      }
    }
  }, {
    key: "reset",
    value: function reset() {
      this.errors = {};
      this.values = deepCopy(this.initialValues);
      this.notify('*');
    }
  }, {
    key: "error",
    value: function error() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var name = args[0],
          value = args[1];
      if (args.length === 0) return this.errors;

      if (typeof name === 'number') {
        name = Object.keys(this.errors)[name];
      }

      if (args.length === 2) {
        if (value === undefined) {
          delete this.errors[name];
        } else {
          this.errors[name] = value;
        }
      }

      return this.errors[name];
    }
  }, {
    key: "validate",
    value: function validate(name) {
      var _this2 = this;

      if (name === undefined) {
        Object.keys(this.rules).forEach(function (n) {
          return _this2.validate(n);
        });
        this.notify('*');
        var message = this.error(0);

        var _error = message === undefined ? undefined : new Error(message);

        return [_error, this.get()];
      } else {
        var validator = this.rules[name];

        var _value = this.get(name);

        var result = validator ? validator(_value, this.values) : true;

        var _message = this.error(name, result === true ? undefined : result || '');

        var _error2 = _message === undefined ? undefined : new Error(_message);

        return [_error2, _value];
      }
    }
  }, {
    key: "subscribe",
    value: function subscribe(listener) {
      var _this3 = this;

      this.listeners.push(listener);
      return function () {
        var index = _this3.listeners.indexOf(listener);

        if (index > -1) _this3.listeners.splice(index, 1);
      };
    }
  }]);

  return FormStore;
}();

function useFormStore() {
  var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var rules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return useMemo(function () {
    return new FormStore(values, rules);
  }, [values, rules]);
}

function useFormChange(store, onChange) {
  useEffect(function () {
    if (!store) return;
    return store.subscribe(function (n) {
      onChange(n);
    });
  }, [store]);
}

export { Form, FormField, FormItem, FormStore, useFieldChange, useFormChange, useFormStore };
//# sourceMappingURL=index.js.map
