export declare type FormListener = (name: string) => void;
export declare type FormValidator = (value: any, values: any) => boolean | string;
export declare type FormRules = {
    [key: string]: FormValidator;
};
export declare type FormErrors = {
    [key: string]: string | undefined;
};
export declare class FormStore<T extends Object = any> {
    private initialValues;
    private listeners;
    private values;
    private rules;
    private errors;
    constructor(values?: Partial<T>, rules?: FormRules);
    private notify;
    get(name?: string): any;
    set(values: Partial<T>): void;
    set(name: string, value: any, validate?: boolean): void;
    reset(): void;
    error(): FormErrors;
    error(name: number | string): string | undefined;
    error(name: string, value: string | undefined): string | undefined;
    validate(): [Error | undefined, T];
    validate(name: string): [Error | undefined, any];
    subscribe(listener: FormListener): () => void;
}
